#include "audiosink.h"

AudioSink::AudioSink(int limit, UINT32 frame_sz, UINT32 buffer_sz):
buffer_size(buffer_sz),
frame_size(frame_sz),
frame_limit(limit*frame_sz),
frame_count(0)
{
	store=new (std::nothrow) BYTE[frame_limit];
	if(store==0)
	{
		std::cout<<"Not enough memory!"<<std::endl;
		
	}
	else
	{
		std::cout<<"AudioSink ready."<<std::endl;
	}
}

AudioSink::~AudioSink()
{
	delete[] store;
	std::cout<<"AudioSink deleted."<<std::endl;
}

void AudioSink::CopyData(BYTE* pData,UINT32 numFramesAvailable,BOOL* pbDone, DWORD flag)
{
	if(store==0)
	{
		std::cout<<"no storage space"<<std::endl;
		return;
	}
	if((frame_count+numFramesAvailable*frame_size)<frame_limit)
	{
		UINT32 framesToCopy = numFramesAvailable;
        if (framesToCopy != 0)
        {
                    if (flag & AUDCLNT_BUFFERFLAGS_SILENT)
                    {
                        ZeroMemory(&store[frame_count], framesToCopy*frame_size);
                    }
                    else
                    {
                        CopyMemory(&store[frame_count], pData, framesToCopy*frame_size);
					}

                    frame_count += framesToCopy*frame_size;
        }
	}
	else
	{
		*pbDone=true;
	}
}

void AudioSink::WriteFile()
{
	std::ofstream ofs;
	ofs.open ("raw.dat", std::ofstream::out | std::ofstream::trunc);
	
	for(UINT32 i=0;i<frame_limit;i++)
	{
		ofs<<(int)store[i]<<std::endl;
	}

	ofs.close();
}

 __int16 AudioSink::CharToInt(unsigned char first, unsigned char second )
{
	__int16 temp;
	__int16 ret;

	ret=first;
	ret=ret<<8;
	temp=second;

	ret=ret|temp;
	
	return ret;
}

void AudioSink::WriteFileInt(int time)
{
	std::ofstream ofs;
	ofs.open ("record.dat", std::ofstream::out | std::ofstream::trunc);
	
	unsigned int onesec=(44100*4)-1;
	unsigned int Fs_x_time=(44100*(time+1))*4-1;
	for(UINT32 i=0;i<frame_limit;i+=4)
	{
		if (i>Fs_x_time)
		{
			break;
		}
		else if (i>onesec)
		{
		__int16 ch1=CharToInt(store[i+1],store[i]);
		__int16 ch2=CharToInt(store[i+3],store[i+2]);
		double output_ch1=double(ch1)/(32767.0);
		double output_ch2=double(ch2)/(32767.0);
		ofs<< output_ch1 << "\t\t" << output_ch2 <<std::endl;
		}
	}

	ofs.close();
}
